#include <diskio/diskio.h>
#include <fat/fat.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "shared.h"
#include "shared.h"

static uint8 block[0x4000];

void deinterleave_block(uint8 *src)
{
    int i;
    memcpy(block, src, 0x4000);
    for(i = 0; i < 0x2000; i += 1)
    {
        src[i*2+0] = block[0x2000 + (i)];
        src[i*2+1] = block[0x0000 + (i)];
    }
}

int load_rom(char *filename)
{
	int size, offset = 0;
	uint8 header[0x200];

	printf("\t\t Malloc\n");
	uint8 *ptr=malloc(1024*1024);

//	int size;
	int fd;


	printf("\t\tLoadrom\nOuverture de %s\n",filename);

	fd = open(filename, O_RDONLY);

	if(!fd) return (NULL);	


	struct stat stat;

	fstat(fd, &stat);

	size=stat.st_size;

	printf("\t\t %s avec une taille de %d\n",filename,size);

	read(fd, ptr, size);

	printf("\t\t %s avec une taille de %d\n",filename,size);

	if(!ptr)
	{	
		return (0);
	}
	if((size / 512) & 1)
	{
		int i;

		size -= 512;
		offset += 512;

		memcpy(header, ptr, 512);

		for(i = 0; i < (size / 0x4000); i += 1)
		{
			deinterleave_block(ptr + offset + (i * 0x4000));
		}
	}
	memset(cart_rom, 0, 0x400000);
	if(size > 0x400000) size = 0x400000;

	memcpy(cart_rom, ptr + offset, size);

	/* Free allocated file data */

	free(ptr);

	return (1);
}



