#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <xenos/xe.h>
#include <input/input.h>
#include <time/time.h>
#include <ppc/timebase.h>
#include "shared.h"


#include "smsmain.h"
#include "xenon_video.h"

#include <SDL/SDL.h>
#include "shared.h"

//#define DEBUG printf("\tDEBUG %s:%s(); at line %d:",__FILE__,__func__,__LINE__ );

/** Initialisation de la console **/
void xb360Init()
{
	xenos_init();
	console_init();
	kmem_init();

	usb_init();
	usb_do_poll();
}

#include <newlib/dirent.h>
void ldir()
{
	struct dirent *lecture;
	DIR *rep;
	rep = opendir("uda:" );
	while ((lecture = readdir(rep))) {
		printf("%s\n", lecture->d_name);
	}
	closedir(rep); 

}

int main ()
{

	//printf("\t\t\tinit ....\n");
	//Initialisation de l'affichage et Initialisation de la console
	xb360Init();
	initVideo();

	int running = 1;
	
	error_init();
	
	ldir();

	printf("\t\t\tinit ....Ok\n");
	/* Load game */
	if(!load_rom("uda:/SONIC.BIN"))
	{
		char caption[256];
		sprintf(caption, "Error loading file `%s'.", "sonic.bin");
		//MessageBox(NULL, caption, "Error", 0);
		printf("\t\t\t%s",caption);
		exit(1);
	}
	printf("\t\t\tmemset\n");
	memset(&bitmap, 0, sizeof(t_bitmap));
	bitmap.width  = 256;
	bitmap.height = 224;
	bitmap.depth  = 16;
	bitmap.granularity = 2;

	printf("\t\t\tbitmap.pitch\n");

	bitmap.pitch = gfxplane->pitch;
	bitmap.data   = (uint16*)(((unsigned char*)gfxplane->base) + gfxplane->pitch * 2 + 2 * 2);
	bitmap.viewport.w = 256;
	bitmap.viewport.h = 224;
	bitmap.viewport.x = 0x00;
	bitmap.viewport.y = 0x00;
	bitmap.remap = 1;
	
	printf("\t\t\tsystem_init\n");

	system_init();
	system_reset();

	printf("\t\t\trunning");

	while(running)
	{

		update_input();
		system_frame(0);//avance
		updateVideo();
	}

	system_shutdown();
	error_shutdown();

	return 0;
}


/* Check if a key is pressed */
int check_key(int code)
{
#if 0
    static char lastbuf[0x100] = {0};

    if((!keystate[code]) && (lastbuf[code] == 1))
        lastbuf[code] = 0;

    if((keystate[code]) && (lastbuf[code] == 0))
    {
        lastbuf[code] = 1;
        return (1);
    }                                                                    
#endif
    return (0);
}

int update_input(void)
{

}


